﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.ScheduleView;

namespace SilverlightApplication16
{
	public class CustomSpecialSlotStyleSelector : ScheduleViewStyleSelector
	{
		public Style DefaultStyle { get; set; }
		public Style ReadOnlyStyle { get; set; }
		public Style SaturdayStyle { get; set; }
		public Style SundayStyle { get; set; }

		public override Style SelectStyle(object item, DependencyObject container, ViewDefinitionBase activeViewDefinition)
		{
			if (item is DefaultOccurence)
				return this.DefaultStyle;
			else if (item is ReadOnlyOccurence)
				return this.ReadOnlyStyle;
			else if (item is SundayOccurence)
				return this.SundayStyle;
			else if (item is SaturdayOccurence)
				return this.SaturdayStyle;
			return base.SelectStyle(item, container, activeViewDefinition);
		}
	}

	public class DefaultOccurence : Slot
	{
		public override Slot Copy()
		{
			return new DefaultOccurence()
			{
				Start = this.Start,
				End = this.End,
				RecurrencePattern = this.RecurrencePattern.Copy()
			};
		}
	}

	public class ReadOnlyOccurence : Slot
	{
		public override Slot Copy()
		{
			return new ReadOnlyOccurence()
			{
				Start = this.Start,
				End = this.End,
				IsReadOnly = true,
				RecurrencePattern = this.RecurrencePattern.Copy()
			};
		}
	}

	public class SaturdayOccurence : Slot
	{
		public override Slot Copy()
		{
			var slot = new SaturdayOccurence();
			slot.CopyFrom(this);
			return slot;
		}

		public override void CopyFrom(Slot other)
		{
			var otherSlot = other as SaturdayOccurence;
			if (otherSlot == null)
				return;
			base.CopyFrom(otherSlot);
		}
	}

	public class SundayOccurence : Slot
	{
		public override Slot Copy()
		{
			var slot = new SundayOccurence();
			slot.CopyFrom(this);
			return slot;
		}

		public override void CopyFrom(Slot other)
		{
			var otherSlot = other as SundayOccurence;
			if (otherSlot == null)
				return;
			base.CopyFrom(otherSlot);
		}
	}

}
