﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Telerik.Windows.Controls.ScheduleView;
using Telerik.Windows.Controls;

namespace SilverlightApplication16
{
	public partial class MainPage : UserControl
	{
		public MainPage()
		{
			InitializeComponent();
			scheduleView.AppointmentsSource = new ObservableCollection<Appointment>();
			var resources = new List<Resource>() { new Resource("Room1"), new Resource("Room2") };
			var type = new ResourceType("Room");
			type.Resources.AddRange(resources);
			scheduleView.ResourceTypesSource = new ObservableCollection<ResourceType>() { type };
			this.SetupSpecialSlots();
		}

		private void SetupSpecialSlots()
		{
			ObservableCollection<Slot> specialSlots = new ObservableCollection<Slot>();

			DateTime start = new DateTime(DateTime.Today.Year, 1, 1, 0, 0, 0);
			DateTime end = new DateTime(DateTime.Today.Year, 1, 1, 23, 59, 59);

			var saturday = new SaturdayOccurence()
			{
				Start = start,
				End = end,
				IsReadOnly = false,
				TimeZone = TimeZoneInfo.Local,
				RecurrencePattern = new RecurrencePattern(null, RecurrenceDays.Saturday, RecurrenceFrequency.Weekly, 1, null, null)
			};
			saturday.Resources.Add(new Resource("Room1","Room"));
			specialSlots.Add(saturday);
			var sunday = new SundayOccurence()
			{
				Start = start,
				End = end,
				IsReadOnly = true,
				TimeZone = TimeZoneInfo.Local,
				RecurrencePattern = new RecurrencePattern(null, RecurrenceDays.Sunday, RecurrenceFrequency.Weekly, 1, null, null)
			};
			sunday.Resources.Add(new Resource("Room1", "Room"));
			specialSlots.Add(sunday);

			scheduleView.SpecialSlotsSource = specialSlots;
		}

	}
}
